##----------------------------------------------------------------------------#
## Copyright (C) 2004  Payam Moghaddam

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
##----------------------------------------------------------------------------#

import pygame
import GFX
import Money
import random
import Level
import Ship
import Features
import LevelA
import LevelB
import LevelC
import LevelD
import LevelE
import LevelF
import LevelG
import LevelH
import LevelI
import LevelJ

def init():
    global screen, background, gfx, playscreen, enemylist, level, enemysprites, sfx
    screen = GFX.screen
    background = GFX.background
    gfx = GFX.gfx
    sfx = GFX.sfx
    enemylist = GFX.enemylist
    level = Level.stage
    enemysprites = GFX.enemysprites
    playscreen = GFX.playarea

class Enemies(pygame.sprite.Sprite):
    def __init__ (self):
        pygame.sprite.Sprite.__init__ (self)
        self.image = GFX.gfx['alien']
        self.explosion = GFX.animstrip(GFX.gfx['explosion2'])
        self.rect  = self.image.get_rect()
        self.area = GFX.playarea
        GFX.enemylist.append(self)
        self.dead = 0
        self.health = 1
        self.frames = 0
        self.speed = 0
        self.direction = 0
        self.chance = 100
        self.position = 0
        self.shootspeed = 3
        self.time = 0
        
    def update(self):
        screen.blit(background, self.rect, self.rect)
        if not self.dead:
            if level.level == 1:
                self.rect, self.frames = LevelA.enemy(self.frames, self.rect, self.group)
            elif level.level == 2:
                self.rect, self.frames = LevelB.enemy(self.frames, self.rect, self.group)
            elif level.level == 3:
                self.rect, self.direction = LevelC.enemy(self.rect, self.direction, self.group)
            elif level.level == 4:
                self.rect, self.direction = LevelD.enemy(self.rect, self.direction, self.group)
            elif level.level == 5:
                self.rect, self.direction = LevelE.enemy(self.rect, self.direction, self.group)
                rr = random.choice((range(200)))
                if rr == 50:
                    if self in enemysprites.sprites():
                        GFX.enemysprites.remove(self)
                        GFX.disappear.add(self)
                if rr in range(10):
                    if self not in enemysprites.sprites():
                        GFX.enemysprites.add(self)
                        GFX.disappear.remove(self)
            elif level.level == 6:
                self.rect, self.direction, self.position = LevelF.enemy(self.rect, self.direction, self.speed, self.position)
            elif level.level == 7:
                self.rect, self.direction, self.position = LevelG.enemy(self.rect, self.direction, self.speed, self.position)
            elif level.level == 8:
                self.rect, self.direction = LevelH.enemy(self.rect, self.direction, self.speed)
            elif level.level == 9:
                self.rect, self.direction, self.position = LevelI.enemy(self.rect, self.direction, self.speed, self.position)
            elif level.level == 10:
                self.rect, self.direction, self.position = LevelJ.enemy(self.rect, self.direction, self.speed, self.position)
                
            rr = random.choice((range(self.chance)))
            if rr == 1:
                #sfx['enemybullet'].play()
                if Ship.ship1.rect.centery < self.rect.centery and Ship.ship2.rect.centery < self.rect.centery:
                    GFX.enemybulletlist[0].shoot((0,-self.shootspeed), 5, self.rect.top - 10, self.rect.centerx)
                elif Ship.ship1.rect.centery > self.rect.centery and Ship.ship2.rect.centery > self.rect.centery:
                    GFX.enemybulletlist[0].shoot((0,self.shootspeed), 5, self.rect.bottom + 10, self.rect.centerx)
                else:
                    x = random.choice((1,2))
                    if x == 1: GFX.enemybulletlist[0].shoot((0,self.shootspeed), 5, self.rect.bottom + 10, self.rect.centerx)
                    else: GFX.enemybulletlist[0].shoot((0,-self.shootspeed), 5, self.rect.top - 10, self.rect.centerx)
        else:
            try:
                self.image = self.explosion[int(self.time)]
                self.time += 1
            except:
                GFX.enemylist.append(self)
                self.kill()
            
            
    def restore(self):
        self.time = 0 
        self.dead = 0
        GFX.enemylist.remove(self)
        GFX.enemysprites.add(self)
        
    def hit(self, ship, damage):
        self.health -= damage
        if self.health <= 0:
            #sfx['explosion'].play()
            if ship == 'ship1':
                Features.player1.updateScore(10)
            elif ship == 'ship2':
                Features.player2.updateScore(10)
            randomnumber = random.choice((range(20)))
            if randomnumber == 1:
                Money.Money(self.rect.center)
            center = self.rect.center
            screen.blit(background, self.rect, self.rect)
            self.image = self.explosion[0]
            self.rect = self.image.get_rect()
            self.rect.center = center
            self.dead = 1
            GFX.enemysprites.remove (self)
            GFX.bulletsprites.add (self)
            

class Enemybullets(pygame.sprite.Sprite):                    ##Bullets Class##
    #The bullets what will be shot

    def __init__ (self):
        pygame.sprite.Sprite.__init__ (self)
        self.image = GFX.gfx['enemybullet']
        self.rect  = self.image.get_rect()
        self.name = 'enemybullet'
	self.area = playscreen
        self.stop = 1
        GFX.enemybulletlist.append(self)
        

    def shoot(self, direction, speed, centery, centerx):
        self.speed = speed
        self.direction = direction
        GFX.enemybulletlist.remove (self)
        self.add (GFX.bulletsprites)
        self.rect.centery = centery
        self.rect.centerx = centerx
        self.stop = 0
        
    def update(self):                           
        if self.stop == 0:
            screen.blit(background, self.rect, self.rect)
            self.rect.move_ip (self.direction)
            # hits blocks
            if pygame.sprite.spritecollide (self, GFX.playersprites, 0):
                self.hit()
                otherplayerhit = pygame.sprite.spritecollide (self, GFX.playersprites, 0)
                for x in otherplayerhit:
                    x.hit()
                
            elif self.rect.top < self.area.top or self.rect.bottom > self.area.bottom:
                self.hit()
                

    def hit(self):
        self.kill()
        self.stop = 1
        GFX.bulletsprites.remove (self)
        GFX.enemybulletlist.append (self)
