##----------------------------------------------------------------------------#
## Copyright (C) 2004  Payam Moghaddam

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
##----------------------------------------------------------------------------#

from pygame.locals import *
import pygame
import os

pygame.init()
def load_image(name):
    """ Load image and return image object"""
    fullname = os.path.join('data', 'gfx', name)
    try:
            image = pygame.image.load(fullname)
            #if image.get_alpha() is None:
            #	image = image.convert()
            #else:
            image = image.convert_alpha()
    except pygame.error, message:
            print 'Cannot load image:', fullname
            raise SystemExit, message
    return image

def load_sound (file):
    """ Loads a sound """
    file = os.path.join ('data', 'sfx', file)
    sound = pygame.mixer.Sound(file)
    return sound

def animstrip(img, width=0):
    if not width:
        width = img.get_height()
    size = width, img.get_height()
    images = []
    origalpha = img.get_alpha()
    origckey = img.get_colorkey()
    img.set_colorkey(None)
    img.set_alpha(None)
    for x in range(0, img.get_width(), width):
        i = pygame.Surface(size)
        i.blit(img, (0, 0), ((x, 0), size))
        if origalpha:
            i.set_colorkey((0,0,0))
        elif origckey:
            i.set_colorkey(origckey)
        images.append(i)
    img.set_alpha(origalpha)
    img.set_colorkey(origckey)
    return images            

def initialise():
    # Initialise Screen
    global screen, playarea
    screen = pygame.display.set_mode((820, 620))
    playarea = Rect(10,0,800,600)
    pygame.display.set_caption('Payams Space Raiders on Crack')

    # Fill background
    global background, emptybackground
    background = pygame.Surface(screen.get_size())
    background = background.convert()
    background.fill((0, 0, 0))
    background.fill((255,255,255), Rect (0,600,820,1))
    screen.blit(background, (0, 0))
    
    emptybackground = pygame.Surface(screen.get_size())
    emptybackground = background.convert()
    emptybackground.fill((0, 0, 0))

    #GFX
    global gfx
    gfx = {'bullet': load_image('bullet.png'),
           'bullet1': load_image('bullet1.png'),
           'explosion': load_image('explosion.png'),
           'bullet2': load_image('bullet2.png'),
           'bullet3': load_image('bullet3.png'),
           'bullet4': load_image('newbullet.png'),
           'enemybullet': load_image('enemybullet.png'),
           'blueship': load_image('simpleship.png'),
           'redship': load_image('simpleshipred.png'),
           'menu': load_image('weaponmenu.PNG'),
           'pointer': load_image('pointer.png'),
           'alien': load_image('enemy.gif'),
           'alien2': load_image('alien1.png'),
           'alien3': load_image('alien2.png'),
           'alien4': load_image('alien3.png'),
           'alien5': load_image('alien4.png'),
           'alien6': load_image('alien5.png'),
           'money': load_image('money.png'),
           'lifebar1': load_image('Lifebar.png'),
           'lifebar2': load_image('Lifebar2.png'),
           'emptybar': load_image('Lifebar1.png'),
           'explosion2': load_image('explosion2.png')}
    
    global sfx
    sfx = {'enemybullet': load_sound('Enemyshoot.wav'),
           'bullet': load_sound('Gunfire.wav'),
           'explosion': load_sound('Bang.wav')}
    
playersprites = pygame.sprite.RenderClear()
bulletsprites = pygame.sprite.RenderClear()
enemysprites = pygame.sprite.RenderClear()
disappear = pygame.sprite.RenderPlain()
weaponmenu = pygame.sprite.RenderPlain()
moneysprites = pygame.sprite.RenderClear()
enemybulletsprites = pygame.sprite.RenderClear()

    



moneylist = []
dirtyrects = []
bulletlist = []
enemylist = []
enemybulletlist = []

def update():
    playersprites.update()
    enemysprites.update()
    bulletsprites.update()
    disappear.update()
    moneysprites.update()
    playersprites.draw(screen)
    bulletsprites.draw(screen)
    enemysprites.draw(screen)
    moneysprites.draw(screen)
    pygame.display.flip()
    

