##----------------------------------------------------------------------------#
## Copyright (C) 2004  Payam Moghaddam

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
##----------------------------------------------------------------------------#

import pygame
import GFX
import Features

class Money(pygame.sprite.Sprite):                    ##Bullets Class##
    #The bullets what will be shot

    def __init__ (self, center):
        pygame.sprite.Sprite.__init__ (self)
        self.image = GFX.gfx['money']
        self.rect  = self.image.get_rect()
	self.rect.center = center
        self.add(GFX.moneysprites)
        self.dead = 0

    def update(self):
        if not self.dead:
            GFX.screen.blit(GFX.background, self.rect, self.rect)
            self.rect.move_ip (0,2)
            if pygame.sprite.spritecollide (self, GFX.playersprites, 0):
                player = pygame.sprite.spritecollide (self, GFX.playersprites, 0)
                self.hit(player[0].name)
            if self.rect.top > GFX.playarea.bottom:
                self.hit()

    def restore(self, center):
        GFX.moneysprites.add(self)
        GFX.moneylist.remove(self)
        self.dead = 0
        
    def hit(self, ship=0):
        if ship != 0:
            if ship == 'ship1':
                Features.player1.updateMoney(100)
            elif ship == 'ship2':
                Features.player2.updateMoney(100)
        GFX.moneylist.append(self)
        GFX.moneysprites.remove(self)
        self.dead = 1
