##----------------------------------------------------------------------------#
## Copyright (C) 2004  Payam Moghaddam

## This program is free software; you can redistribute it and/or
## modify it under the terms of the GNU General Public License
## as published by the Free Software Foundation; either version 2
## of the License, or (at your option) any later version.
 
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
##----------------------------------------------------------------------------#

#To do
#-Finish the inventory buy
#- Add ability, to upgrade current weapons, rather than having to buy new ones.
#- Add defense upgrade abilities.
#- Use dictionary or wtv, for enemies loading, because very long but exact same code



from pygame.locals import *
import pygame
import sys
import GFX
import Ship
import Enemy
import Level
import Features
import time
import os


playscreen = Rect (10, 0, 800, 600)
def main():
    #Set up screen and background
    pygame.init()
    GFX.initialise()

    #Start up ships
    global ship1, ship2
    Ship.init()
    ship1 = Ship.ship1
    ship2 = Ship.ship2
    
    #Setup some bullets/enemies
    Features.init()
    Level.init()
    Enemy.init()
    [Enemy.Enemybullets() for x in range(200)]
    [Ship.Bullets() for x in range(100)]
    [Enemy.Enemies() for x in range(36)]

    #Start up the players
    global player1, player2
    player1 = Features.player1
    player2 = Features.player2
    
    #Start level
    global level
    level = Level.stage
    #level.level = 7 

    # Event loop
    global frames
    ship1rate = Ship.ship1.shootrate
    frames = 0.0
    clock = pygame.time.Clock()
    messages = 0
    while 1:
        # Make sure game doesn't run at more than 60 frames per second
        clock.tick(60)
        pygame.event.pump()
        keyinput = pygame.key.get_pressed()

        for e in pygame.event.get([KEYDOWN,KEYUP]):
            if e.type == KEYDOWN:
                if keyinput[K_m]:
                    Ship.ship1.shoot()
                    frames = 0.0
                if keyinput[K_n]:
                    Ship.ship1.spin()
                if keyinput[K_q]:
                    Ship.ship2.shoot()
                if keyinput[K_f]:
                    Ship.ship1.bullettype += 1
                if keyinput[K_g]:
                    print clock.get_fps() 
                if keyinput[K_b]:
                    ship1rate = Ship.ship1.shootrate = Ship.ship1.shootrate + 0.1
            
        if keyinput[K_m]:
            if int(frames) == 1:
                ship1.shoot()
                frames = 0
        if keyinput[K_RIGHT]:
            Ship.ship1.moveright ()

        if keyinput[K_d]:
            Ship.ship2.moveright ()
            
        if keyinput[K_LEFT]:
            Ship.ship1.moveleft ()

        if keyinput[K_a]:
            Ship.ship2.moveleft ()

        if keyinput[K_UP]:
            Ship.ship1.moveup ()

        if keyinput[K_w]:
            Ship.ship2.moveup ()
            
        if keyinput[K_DOWN]:
            Ship.ship1.movedown ()

        if keyinput[K_s]:
            Ship.ship2.movedown ()

        if len(GFX.enemysprites) + len(GFX.disappear) == 0:
            message = 0
            level.new()

        if message >= 6:
            level.message.remove()
            
        if keyinput[K_ESCAPE] or pygame.event.peek(QUIT):
            sys.exit()

        frames += ship1rate
        message += 0.1
        GFX.update()
        
if __name__ == '__main__':
    main()
